/*
 *
 * Copyright (c) 2003-2004 Erez Zadok
 * Copyright (c) 2003-2004 Swapnil V. Patil
 * Copyright (c) 2003-2004 Anand Kashyap
 * Copyright (c) 2003-2004 Gopalan Sivathanu
 * Copyright (c) 2003-2004 Stony Brook University
 * Copyright (c) 2003-2004 The Research Foundation of State University of New York
 *
 * For specific licensing information, see the COPYING file distributed with
 * this package.
 *
 * This Copyright notice must be kept intact and distributed with all sources.
 */


# include <stdio.h>
# include <unistd.h>
# include <sys/mount.h>
# include <string.h>
# include <stdlib.h>

// print program usage syntax and exit

void usage(void)	{
	printf("\nUsage: i3fs_mount <source directory> <mount point> -o <options>\n");
	printf("Options:\n");
	printf("logfile=<path>\n");
	printf("dbdir=<path>\n\n");
	exit(0);
}


int main(int argc, char **argv)	{
	char options[100];
	char *pass;
	int err=0;

// Number of arguments can either be 3 or 5 and not anything else

	if (argc != 5 && argc != 3)
		usage();


	if (argc == 5)	{
		if (strcmp(argv[3], "-o"))
			usage();
	}


	strcpy(options, "dir=");
	strcat(options, argv[1]);
	strcat(options, ",pass=");

	pass = (char*)getpass("Enter the passphrase: ");

	strcat(options, pass);

	if (argc == 5)	{
		strcat(options, ",");
		strcat(options, argv[4]);
	}

	if (argc == 4)	{
		strcat(options, " -o ");
		strcat(options, argv[3]);
	}

	err = mount(argv[1], argv[2], "i3fs", 0, options);

	if (err == 0)	{
		printf("\nI3FS mounted successfully\n");
	}
	else	{
		printf("\nFATAL: An error occured during mount.\n");
		perror((char*)err);
	}

	return 0;	
	
}
